diff -ur sendmail-8.14.2/cf/README sendmail-8.14.2-badrcptshutdown/cf/README
--- sendmail-8.14.2/cf/README	2007-04-03 23:26:58.000000000 +0200
+++ sendmail-8.14.2-badrcptshutdown/cf/README	2007-12-20 10:20:56.000000000 +0100
@@ -4153,6 +4153,23 @@
 					transaction have been rejected, sleep
 					for one second after each subsequent
 					RCPT command in that transaction.
+confBAD_RCPT_SHUTDOWN BadRcptShutdown	[infinite] If set and the specified
+					number of recipients in a single SMTP
+					transaction have been rejected and
+					the percentage of bad recipients of
+					the total recipients as specified by
+					BadRcptShutdownGood has been met,
+					shutdown the connection with a 421
+					code.
+confBAD_RCPT_SHUTDOWN_GOOD BadRcptShutdownGood
+					[zero] Percentage of bad recipients
+					of the total recipients before shutdown
+					is allowed.  If 100, the connection
+					will never be shut down if there are
+					any good recipients.  If 0 the
+					connection will be shut down as soon
+					as BadRcptShutdown bad rcpts are
+					reached.
 confDONT_PROBE_INTERFACES  DontProbeInterfaces
 					[False] If set, sendmail will _not_
 					insert the names and addresses of any
diff -ur sendmail-8.14.2/cf/m4/proto.m4 sendmail-8.14.2-badrcptshutdown/cf/m4/proto.m4
--- sendmail-8.14.2/cf/m4/proto.m4	2007-04-20 02:53:30.000000000 +0200
+++ sendmail-8.14.2-badrcptshutdown/cf/m4/proto.m4	2007-12-20 10:20:55.000000000 +0100
@@ -580,6 +580,19 @@
 # once the threshold number of recipients have been rejected
 _OPTION(BadRcptThrottle, `confBAD_RCPT_THROTTLE', `0')
 
+ifdef(`_FFR_BADRCPT_SHUTDOWN', `dnl
+# Number of bad recipients before connection is evaluated for
+# shutdown with 421 code. Zero disables. Numbers less than 5 not
+# recommended.
+_OPTION(BadRcptShutdown, `confBAD_RCPT_SHUTDOWN', `0')
+# Percentage of bad recipients of total before shutdown is 
+# allowed. 81 is a good number, only dropping connection if 
+# 2 out of 10 rcpts or less are good.
+# If 100, the connection will never be shut down if there are any good
+# recipients.  If 0 the connection will be shut down as soon as
+# BadRcptShutdown bad rcpts are reached.
+_OPTION(BadRcptShutdownGood, `confBAD_RCPT_SHUTDOWN_GOOD', `0')')
+
 # shall we get local names from our installed interfaces?
 _OPTION(DontProbeInterfaces, `confDONT_PROBE_INTERFACES', `False')
 
diff -ur sendmail-8.14.2/doc/op/op.me sendmail-8.14.2-badrcptshutdown/doc/op/op.me
--- sendmail-8.14.2/doc/op/op.me	2007-06-23 01:08:59.000000000 +0200
+++ sendmail-8.14.2-badrcptshutdown/doc/op/op.me	2007-12-20 10:20:56.000000000 +0100
@@ -6522,6 +6522,18 @@
 If set and the specified number of recipients in a single SMTP
 transaction have been rejected, sleep for one second after each subsequent
 RCPT command in that transaction.
+.ip BadRcptShutdown=\fIN\fP
+[no short name]
+If set and the specified number of recipients in a single SMTP transaction
+have been rejected and the percentage of bad recipients of the total
+recipients as specified by BadRcptShutdownGood has been met, shutdown the
+connection with a 421 code.
+.ip BadRcptShutdownGood=\fIN\fP
+[no short name]
+If set, the percentage of bad recipients of the total recipients before
+shutdown is allowed.  If 100, the connection will never be shut down if
+there are any good recipients.  If 0 the connection will be shut down as
+soon as BadRcptShutdown bad rcpts are reached.
 .ip BlankSub=\fIc\fP
 [B]
 Set the blank substitution character to
